# ------------------------------------------------------------
# ol2ics.pl outlook to ics export
# m@wjst.de 26Dec07
# ------------------------------------------------------------
#!/usr/local/bin/perl

if ($ARGV[0] eq "") {
	print ("OL2ICS export.ics categoryname\n");
	exit(1);
}

open(OUT,">$ARGV[0]");
print OUT ("BEGIN:VCALENDAR\nVERSION:2.0\nPRODID:-//RSB//ICSCATEG//EN\n");
$b="BEGIN:VEVENT\n";
$e="END:VEVENT\n";

use Win32::OLE;
use Win32::OLE::Const 'Microsoft Outlook';

my $outlook = Win32::OLE->new('Outlook.Application') or die "Error!\n";
my $namespace = $outlook->GetNamespace("MAPI") or die "can't open MAPI namespace\n";;
my $folder = $namespace->GetDefaultFolder(olFolderCalendar);

my $items = $folder->Items;
for my $itemIndex (1..$items->Count) {
	my $message = $items->item($itemIndex);
	next if not defined $message;

	$s="SUMMARY:" . $message->{Subject} . "\n";
	# $message->{Body}
	# $message->{IsRecurring}

	$l="LOCATION:" . $message->{Location} . "\n";
	if ($message->{AllDayEvent} eq 1) {
		$t="DTSTART;VALUE=DATE:" . $message->{Start}->Date("yyyyMMdd") . "\n";
		$d="DTEND;VALUE=DATE:" . $message->{End}->Date("yyyyMMdd") . "\n";
	} 
	else {
		$t="DTSTART:" . $message->{Start}->Date("yyyyMMdd") . "T" . $message->{Start}->Time("hhmmss") . "Z\n";
		$d="DTEND:" . $message->{End}->Date("yyyyMMdd") . "T" . $message->{End}->Time("hhmmss") . "Z\n";
	}
	$c="CATEGORIES:" . $message->{Categories} . "\n";
	if ($message->{item.Sensitivity} eq 2) {
		$p="CLASS:PRIVATE\n";
	}
	elsif ($message->{item.Sensitivity} eq 1) {
		$p="CLASS:CONFIDENTIAL\n";
	}
	else {
		$p="CLASS:PUBLIC\n";
	}
	$m="DTSTAMP:" . $message->{LastModificationTime}->Date("yyyyMMdd") . "T" . $message->{LastModificationTime}->Time("hhmmss") . "Z\n";
	$u="UID:" . $message->{EntryID} . "\n";

	if ( $c =~ /.*($ARGV[1]).*/) {
		print OUT ("$b$s$l$t$d$c$p$m$u$e");
	}
}

print OUT ("END:VCALENDAR");
close OUT;
exit(0);

